// Code generated by counterfeiter. DO NOT EDIT.
package tasklistfakes

import (
	"context"
	"sync"

	"gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/task/internal/service/task"
	"gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/task/internal/service/tasklist"
)

type FakeQueue struct {
	AddTaskListStub        func(context.Context, *tasklist.TaskList, []*task.Task) error
	addTaskListMutex       sync.RWMutex
	addTaskListArgsForCall []struct {
		arg1 context.Context
		arg2 *tasklist.TaskList
		arg3 []*task.Task
	}
	addTaskListReturns struct {
		result1 error
	}
	addTaskListReturnsOnCall map[int]struct {
		result1 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeQueue) AddTaskList(arg1 context.Context, arg2 *tasklist.TaskList, arg3 []*task.Task) error {
	var arg3Copy []*task.Task
	if arg3 != nil {
		arg3Copy = make([]*task.Task, len(arg3))
		copy(arg3Copy, arg3)
	}
	fake.addTaskListMutex.Lock()
	ret, specificReturn := fake.addTaskListReturnsOnCall[len(fake.addTaskListArgsForCall)]
	fake.addTaskListArgsForCall = append(fake.addTaskListArgsForCall, struct {
		arg1 context.Context
		arg2 *tasklist.TaskList
		arg3 []*task.Task
	}{arg1, arg2, arg3Copy})
	stub := fake.AddTaskListStub
	fakeReturns := fake.addTaskListReturns
	fake.recordInvocation("AddTaskList", []interface{}{arg1, arg2, arg3Copy})
	fake.addTaskListMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2, arg3)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeQueue) AddTaskListCallCount() int {
	fake.addTaskListMutex.RLock()
	defer fake.addTaskListMutex.RUnlock()
	return len(fake.addTaskListArgsForCall)
}

func (fake *FakeQueue) AddTaskListCalls(stub func(context.Context, *tasklist.TaskList, []*task.Task) error) {
	fake.addTaskListMutex.Lock()
	defer fake.addTaskListMutex.Unlock()
	fake.AddTaskListStub = stub
}

func (fake *FakeQueue) AddTaskListArgsForCall(i int) (context.Context, *tasklist.TaskList, []*task.Task) {
	fake.addTaskListMutex.RLock()
	defer fake.addTaskListMutex.RUnlock()
	argsForCall := fake.addTaskListArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2, argsForCall.arg3
}

func (fake *FakeQueue) AddTaskListReturns(result1 error) {
	fake.addTaskListMutex.Lock()
	defer fake.addTaskListMutex.Unlock()
	fake.AddTaskListStub = nil
	fake.addTaskListReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeQueue) AddTaskListReturnsOnCall(i int, result1 error) {
	fake.addTaskListMutex.Lock()
	defer fake.addTaskListMutex.Unlock()
	fake.AddTaskListStub = nil
	if fake.addTaskListReturnsOnCall == nil {
		fake.addTaskListReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.addTaskListReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeQueue) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.addTaskListMutex.RLock()
	defer fake.addTaskListMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeQueue) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ tasklist.Queue = new(FakeQueue)
